<template>
  <ValidationObserver v-slot="{ handleSubmit }">
    <CForm
      v-loading="loading"
      class="zone-form"
      @submit.prevent="handleSubmit(onSubmit)"
    >
      <CCard>
        <CCardBody>
          <div class="box-inner-form">
            <ValidationProvider v-slot="{ errors }" rules="required">
              <CInput
                v-model="model.name"
                type="text"
                label="Name"
                placeholder="Enter name"
                horizontal
              >
                <template #prepend-content>
                  <font-awesome-icon :icon="['fas', 'th']" class="width-1x" />
                </template>
                <template #invalid-feedback>
                  <div class="d-block invalid-feedback">
                    {{ errors[0] }}
                  </div>
                </template>
              </CInput>
            </ValidationProvider>

            <CTextarea
              v-model="model.description"
              label="Description"
              placeholder="Description"
              horizontal
              rows="2"
            >
              <template #prepend-content>
                <font-awesome-icon :icon="['fas', 'bars']" class="width-1x" />
              </template>
            </CTextarea>
          </div>
        </CCardBody>

        <CCardFooter>
          <CButton
            type="submit"
            color="primary"
          >
            <font-awesome-icon :icon="['fas', 'save']" class="width-1x" />
            Save
          </CButton>

          <CButton
            color="secondary"
            @click="$emit('close')"
          >
            Cancel
          </CButton>
        </CCardFooter>
      </CCard>
    </CForm>
  </ValidationObserver>
</template>

<style lang="scss" scoped>
  .zone-form {
    .card {
      border-top: 0;
      margin-bottom: 0;
    }
  }
</style>

<script>
import Zone from '~/models/Zone'
import createEditForm from '~/mixins/create-edit-form'

export default {
  mixins: [createEditForm],

  data () {
    return {
      model: new Zone(),
      modelType: 'zone'
    }
  },

  methods: {
    /**
     * set user status
     * @param {Boolean} val
     * @param {Object} event
     */
    setStatus (val, event) {
      this.model.status = parseInt(event.target.value)
    },

    /**
     * Dynamic set model
     * @param {Object} data
     */
    setModel (data) {
      this.model = new Zone(data)
    },

    prepareData () {}
  }
}
</script>
